Package ghidra.pcode.emu.jit.gen.op

# Enum Class StoreOpGen

java.lang.Object
java.lang.Enum<StoreOpGen>
ghidra.pcode.emu.jit.gen.op.StoreOpGen

All Implemented Interfaces:
  `OpGen<JitStoreOp>`, `Serializable`, `Comparable<StoreOpGen>`, `Constable`, `org.objectweb.asm.Opcodes`

public enum StoreOpGen extends Enum<StoreOpGen> implements OpGen<JitStoreOp>
The generator for a `store`.

These ops are currently presumed to be indirect memory accesses. TODO: If we fold constants, we could convert some of these to direct.

We request a field to pre-fetch the `space` and emit code to load it onto the stack. We then emit code to load the offset onto the stack and convert it to a JVM long, if necessary. The varnode size is loaded by emitting an `ldc`. We must now emit code to load the value and convert it to a byte array. The conversion depends on the type of the value. Finally, we emit an invocation of `JitBytesPcodeExecutorStatePiece.JitBytesPcodeExecutorStateSpace.write(long, byte[], int, int)`.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `GEN`
  The generator singleton

- ## Field Summary

  ### Fields inherited from interface org.objectweb.asm.Opcodes

  `AALOAD, AASTORE, ACC_ABSTRACT, ACC_ANNOTATION, ACC_BRIDGE, ACC_DEPRECATED, ACC_ENUM, ACC_FINAL, ACC_INTERFACE, ACC_MANDATED, ACC_MODULE, ACC_NATIVE, ACC_OPEN, ACC_PRIVATE, ACC_PROTECTED, ACC_PUBLIC, ACC_RECORD, ACC_STATIC, ACC_STATIC_PHASE, ACC_STRICT, ACC_SUPER, ACC_SYNCHRONIZED, ACC_SYNTHETIC, ACC_TRANSIENT, ACC_TRANSITIVE, ACC_VARARGS, ACC_VOLATILE, ACONST_NULL, ALOAD, ANEWARRAY, ARETURN, ARRAYLENGTH, ASM10_EXPERIMENTAL, ASM4, ASM5, ASM6, ASM7, ASM8, ASM9, ASTORE, ATHROW, BALOAD, BASTORE, BIPUSH, CALOAD, CASTORE, CHECKCAST, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DLOAD, DMUL, DNEG, DOUBLE, DREM, DRETURN, DSTORE, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F_APPEND, F_CHOP, F_FULL, F_NEW, F_SAME, F_SAME1, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FLOAD, FLOAT, FMUL, FNEG, FREM, FRETURN, FSTORE, FSUB, GETFIELD, GETSTATIC, GOTO, H_GETFIELD, H_GETSTATIC, H_INVOKEINTERFACE, H_INVOKESPECIAL, H_INVOKESTATIC, H_INVOKEVIRTUAL, H_NEWINVOKESPECIAL, H_PUTFIELD, H_PUTSTATIC, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, IF_ACMPEQ, IF_ACMPNE, IF_ICMPEQ, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ICMPLT, IF_ICMPNE, IFEQ, IFGE, IFGT, IFLE, IFLT, IFNE, IFNONNULL, IFNULL, IINC, ILOAD, IMUL, INEG, INSTANCEOF, INTEGER, INVOKEDYNAMIC, INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE, ISUB, IUSHR, IXOR, JSR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDC, LDIV, LLOAD, LMUL, LNEG, LONG, LOOKUPSWITCH, LOR, LREM, LRETURN, LSHL, LSHR, LSTORE, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, MULTIANEWARRAY, NEW, NEWARRAY, NOP, NULL, POP, POP2, PUTFIELD, PUTSTATIC, RET, RETURN, SALOAD, SASTORE, SIPUSH, SOURCE_DEPRECATED, SOURCE_MASK, SWAP, T_BOOLEAN, T_BYTE, T_CHAR, T_DOUBLE, T_FLOAT, T_INT, T_LONG, T_SHORT, TABLESWITCH, TOP, UNINITIALIZED_THIS, V_PREVIEW, V1_1, V1_2, V1_3, V1_4, V1_5, V1_6, V1_7, V1_8, V10, V11, V12, V13, V14, V15, V16, V17, V18, V19, V20, V21, V22, V23, V24, V9`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `generateInitCode(JitCodeGenerator gen, JitStoreOp op, org.objectweb.asm.MethodVisitor iv)`
  Emit bytecode into the class constructor.
  `void`
  `generateRunCode(JitCodeGenerator gen, JitStoreOp op, JitControlFlowModel.JitBlock block, org.objectweb.asm.MethodVisitor rv)`
  Emit bytecode into the `run` method.
  `static StoreOpGen`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static StoreOpGen[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### GEN

    public static final StoreOpGen GEN
    The generator singleton

- ## Method Details

  - ### values

    public static StoreOpGen[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static StoreOpGen valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### generateInitCode

    public void generateInitCode(JitCodeGenerator gen, JitStoreOp op, org.objectweb.asm.MethodVisitor iv)
    Description copied from interface: `OpGen`
    Emit bytecode into the class constructor.
    Specified by:
      `generateInitCode` in interface `OpGen<JitStoreOp>`
    Parameters:
      `gen` - the code generator
      `op` - the p-code op (use-def node) to translate
      `iv` - the visitor for the class constructor

  - ### generateRunCode

    public void generateRunCode(JitCodeGenerator gen, JitStoreOp op, JitControlFlowModel.JitBlock block, org.objectweb.asm.MethodVisitor rv)
    Description copied from interface: `OpGen`
    Emit bytecode into the `run` method.

    This method must emit the code needed to load any input operands, convert them to the appropriate type, perform the actual operation, and then if applicable, store the output operand. The implementations should delegate to `JitCodeGenerator.generateValReadCode(JitVal, JitTypeBehavior, Ext)`, `JitCodeGenerator.generateVarWriteCode(JitVar, JitType, Ext)`, and `TypeConversions` appropriately.

    Specified by:
      `generateRunCode` in interface `OpGen<JitStoreOp>`
    Parameters:
      `gen` - the code generator
      `op` - the p-code op (use-def node) to translate
      `block` - the basic block containing the p-code op
      `rv` - the visitor for the `run` method.